<?php
/**
 * Z-Payment Merchant Gateway for eShop 
 * 
 * @version 1.0.0
 * @author Z-Payment <www.z-payment.com>
 * @copyright Copyright (c) 2014 Z-Payment.
 * 
 * Below are settings required for Wordpress
 * 
 * Plugin Name: Z-Payment Merchant Gateway for eShop 
 * Plugin URI: www.z-payment.com/docs
 * Description: Enables Z-Payment Merchant Gateway within eShop
 * Author:  Z-Payment
 * Version: 1.0.0
 * Author URI: www.z-payment.com
 */
 
if ('zpayment.php' == basename($_SERVER['SCRIPT_FILENAME']))
 	die ('<h2>Direct File Access Prohibited</h2>');
 
register_activation_hook(__FILE__,'eshopzpayment_activate');
function eshopzpayment_activate(){
    /*
    * Activation routines
    */
    global $wpdb;
    $opts=get_option('active_plugins');
    $eshopthere=false;
    foreach($opts as $opt)
	{
		if($opt=='eshop/eshop.php')
			$eshopthere=true;
    }
    if($eshopthere==false){
        deactivate_plugins('zpayment.php'); //Deactivate ourself
        wp_die(__('ERROR! eShop is not active.','eshop'));
    }
}

add_action('eshop_setting_merchant_load','eshopzpaymentqpage');

function eshopzpaymentqpage($thist){
    /*
    * adding the meta box for this gateway
    */
    add_meta_box('eshop-m-zpaymentpage', __('Z-Payment','eshop'), 'zpaymentgateway_box', $thist->pagehook, 'normal', 'core');
}

function zpaymentgateway_box($eshopoptions) {
    /*
    * the meta box content, obviously you have to set up the required fields for your gateway here
    */
	//var_dump($eshopoptions);
    if(isset($eshopoptions['zpayment']))
	{
        $eshopzpayment = $eshopoptions['zpayment'];
    }
	else
	{
        $eshopzpayment['email']='';
        $eshopzpayment['merchant_id']='';
        $eshopzpayment['api_key']='';
    }
	
	echo '<fieldset>';?>
    <p class="cbox">
        <input id="eshop_methodzpayment" name="eshop_method[]" type="checkbox" value="zpayment"<?php if(in_array('zpayment',(array)$eshopoptions['method'])) echo ' checked="checked"'; ?> />
        <label for="eshop_methodzpayment" class="eshopmethod">
            <?php _e('Accept payment by Z-Payment','eshop'); ?>
        </label>
    </p>
  
  <label for="eshop_zpaymentshopid"><?php _e('Shop ID','eshop'); ?></label><input id="eshop_zpaymentshopid" name="zpayment[shop_id]" type="text" value="<?php echo $eshopzpayment['shop_id']; ?>" size="30" maxlength="50" /><br />
	
	<label for="eshop_zpaymentmerchkey"><?php _e('Merchant Key','eshop'); ?></label><input id="eshop_zpaymentmerchkey" name="zpayment[merch_key]" type="text" value="<?php echo $eshopzpayment['merch_key']; ?>" size="30" maxlength="50" /><br />
		
	<label for="eshop_zpaymentinitpass"><?php _e('Initialization Password','eshop'); ?></label><input id="eshop_zpaymentinitpass" name="zpayment[init_pass]" type="text" value="<?php echo $eshopzpayment['init_pass']; ?>" size="30" maxlength="50" /><br />
	
	<label for="eshop_zpaymentmethod"><?php _e('Method','eshop'); ?></label><select id="eshop_zpaymentmethod" name="zpayment[method]">
  <option value='0' <?php if ( $eshopzpayment['method']==0) echo "selected"; ?>>POST</option><option Value='1' <?php if ( $eshopzpayment['method']==1) echo "selected"; ?>>GET</option></select>
	<br />	
  <?php $rlink=add_query_arg(array('eshopaction'=>'zpayment_result'),get_permalink($eshopoptions['cart_success']));
  $flink=add_query_arg(array('eshopaction'=>'zpayment_fail'),get_permalink($eshopoptions['cart_success']));
  $slink=add_query_arg(array('eshopaction'=>'zpayment_success'),get_permalink($eshopoptions['cart_success']));
  ?>
  <p>Result URL: <br /><?php echo $rlink; ?></p>
  <p>Success URL: <br /><?php echo $slink; ?></p>
  <p>Fail URL: <br /><?php echo $flink; ?></p>   
    </fieldset>
<?php
}

add_filter('eshop_setting_merchant_save','zpaymentsave',10,2);
function zpaymentsave($eshopoptions,$posted)
{
    /*
    * save routine for the fields you added above
    */
	//var_dump($eshopoptions);
    global $wpdb;


    $zpaymentpost['shop_id']=$wpdb->escape($posted['zpayment']['shop_id']);
	$zpaymentpost['merch_key']=$wpdb->escape($posted['zpayment']['merch_key']);
	$zpaymentpost['init_pass']=$wpdb->escape($posted['zpayment']['init_pass']);
	$zpaymentpost['method']=$wpdb->escape($posted['zpayment']['method']);
	
	$eshopoptions['zpayment']=$zpaymentpost;
    return $eshopoptions;
}

add_filter('eshop_merchant_img_zpayment','zpaymentimg');
function zpaymentimg($array){
    /*
    * adding the image for this gateway, for use on the front end of the site
    */
    $array['path']=WP_PLUGIN_DIR.'/eshop-zpayment/images/button.png';
    $array['url']=WP_PLUGIN_URL.'/eshop-zpayment/images/button.png';
    return $array;
}

add_filter('eshop_mg_inc_path','zpaymentpath',10,2);
function zpaymentpath($path,$paymentmethod){
    /*
    * adding another necessary link for the instant payment notification of your gateway
    */
    if($paymentmethod=='zpayment')
            return WP_PLUGIN_DIR.'/eshop-zpayment/zpayment.checkout.php';
    return $path;
}

add_filter('eshop_show_success', 'eshop_zpayment_return_fail',10,3);
function eshop_zpayment_return_fail($echo, $eshopaction, $postit){
	global $wpdb, $eshopoptions;
	$detailstable=$wpdb->prefix.'eshop_orders';
	
	$method_num = $eshopoptions['zpayment']['method'];
    if($method_num==0) {$method='POST';} else {$method='GET';} 
    if($method=='POST') $HTTP = $_POST; 
    else $HTTP = $_GET;
    foreach ($HTTP as $Key=>$Value) { $$Key = $Value; }
	
	$shop_id = $eshopoptions['zpayment']['shop_id'];
    $merch_key = $eshopoptions['zpayment']['merch_key'];
    $order = $LMI_PAYMENT_NO;
	$err = FALSE;
	

	
    if($eshopaction=='zpayment_success'){
	 
	 /*запрос статуса счета*/
    $POST_OR_GET = 'GET';                  
    $ACT_URL = 'https://z-payment.com/api/get_status_pay.php';    
    $HASH = md5($shop_id.$order.$merch_key);  
    $Values = "ID_SHOP=$shop_id&ID_INVOICE=$order&HASH=$HASH";
    $url=$ACT_URL."?".$Values;

    $Result = file($url);
    $Result = $Result[0];
    $Data = explode('&', $Result);
    foreach($Data as $Value) {
    $PartValue = explode('=',$Value);
    $ArValue[$PartValue[0]] = $PartValue[1];
    }
    $mail_https7    =   $ArValue['EMAIL'];
    $status_https7  =   $ArValue['STATUS'];
    $status_2_h7    =   $ArValue['STATUS'];
    $mess_https7    =   $ArValue['MESSAGE'];
    $sum_https7     =   $ArValue['SUMMA_PAY'];


         if ($status_2_h7==4 || $status_2_h7==6 || $sum_https7==$LMI_PAYMENT_AMOUNT) {
         //Echo "<a href=$url>link</a>";
	     $query2=$wpdb->query("UPDATE $detailstable set status='Completed',transid='Completed' where checkid='".$wpdb->escape($LMI_PAYMENT_NO)."'");
         $_SESSION = array();
	     session_destroy();
      	 echo  "<div><p><!--Thank you for shopping with us. Your account has been charged and your transaction is successful. We will be shipping your order to you soon.--></p><p>Ваш счет оплачен! Спасибо за покупку!  </p></div>";
         } else {
          echo  '<div><p><font color="red">Transaction Declined. We\'re sorry, but the transaction has failed.</font></p><p><font color="red">Платеж не прошел. Приносим извинения, но транзация не удалась</font></p></div>';
        }
	 	 
	 
	}
	
	
	
	else if($eshopaction=='zpayment_fail'){
    echo  '<div><p><font color="red">Transaction Declined. We\'re sorry, but the transaction has failed.</font></p>
	<p><font color="red">Платеж не прошел. Приносим извинения, но транзация не удалась</font></p>
	</div>';
	}
	
	else if ($eshopaction=='zpayment_result') {
	
	    if(isset($LMI_SECRET_KEY)) {
            if($LMI_SECRET_KEY!=$merch_key) {
            $err = TRUE;
			}
		} else {
        $CalcHash = md5($LMI_PAYEE_PURSE.$LMI_PAYMENT_AMOUNT.$LMI_PAYMENT_NO.$LMI_MODE.$LMI_SYS_INVS_NO.$LMI_SYS_TRANS_NO.$LMI_SYS_TRANS_DATE.$merch_key.$LMI_PAYER_PURSE.$LMI_PAYER_WM);
		    if($LMI_HASH != strtoupper($CalcHash)) 
			{
            $err = TRUE;
	        $notes = 'Declined. Invalid hash';		
		    }
        }
		
		if (!$err) {
		
	 $query2=$wpdb->query("UPDATE $detailstable set status='Completed',transid='Completed' where checkid='".$wpdb->escape($LMI_PAYMENT_NO)."'");
         $_SESSION = array();
	     session_destroy();
	
	}	
		
	}
	

    //return $echo;
	
}

?>